"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observable_1 = require("@reactive-js/observable");
const option_1 = require("@reactive-js/option");
const pipe_1 = require("@reactive-js/pipe");
const createAsyncEnumerable_1 = require("./createAsyncEnumerable");
const map_1 = require("./map");
const scheduler_1 = require("@reactive-js/scheduler");
const createStream = (f) => createAsyncEnumerable_1.createAsyncEnumerable(obs => observable_1.concat(f(obs), observable_1.never()));
const emptyModeMapper = (mode) => mode === 1 ? { type: 2 } : option_1.none;
const onEmptyOperator = pipe_1.compose(observable_1.map(emptyModeMapper), observable_1.keepType(option_1.isSome), observable_1.takeFirst());
exports.emptyStream = () => createStream(onEmptyOperator);
const ofValueOperator = (data) => observable_1.genMap(function* (mode) {
    switch (mode) {
        case 1:
            yield { type: 1, data };
            yield { type: 2 };
    }
});
exports.ofValueStream = (value) => createStream(ofValueOperator(value));
const generateScanner = (generator, delay) => (acc, ev) => ev === 1
    ? observable_1.generate(generator, () => acc, delay)
    : observable_1.empty();
exports.generateStream = (generator, initialValue, delay = 0) => createStream(pipe_1.compose(observable_1.scanAsync(generateScanner(generator, delay), initialValue, 1), observable_1.map(data => ({ type: 1, data }))));
exports.mapStream = (mapper) => map_1.map((ev) => ev.type === 1
    ? {
        type: 1,
        data: mapper(ev.data),
    }
    : { type: 2 });
exports.fromObservableStream = (observable) => createAsyncEnumerable_1.createAsyncEnumerable(modeObs => observable_1.createObservable(subscriber => {
    const pausableScheduler = scheduler_1.toPausableScheduler(subscriber);
    const modeSubscription = pipe_1.pipe(modeObs, observable_1.onNotify(mode => {
        switch (mode) {
            case 2:
                pausableScheduler.pause();
                break;
            case 1:
                pausableScheduler.resume();
                break;
        }
    }), observable_1.subscribe(subscriber));
    const eventStream = observable_1.concat(pipe_1.pipe(observable, observable_1.map(data => ({ type: 1, data }))), observable_1.ofValue({ type: 2 }), observable_1.never());
    const eventStreamSubscription = pipe_1.pipe(eventStream, observable_1.onNotify(x => subscriber.notify(x)), observable_1.subscribe(pausableScheduler));
    subscriber.add(pausableScheduler).add(modeSubscription).add(eventStreamSubscription);
}));
//# sourceMappingURL=stream.js.map